# eslint-config-crowdlab

> ESLint configuration used by CrowdLab

Currently based on
[`eslint-config-airbnb`](https://github.com/airbnb/javascript/tree/master/packages/eslint-config-airbnb) with some additions:

* [`eslint-plugin-jest`](https://github.com/facebook/jest/tree/master/packages/eslint-plugin-jest)
* [`eslint-plugin-import`](https://github.com/benmosher/eslint-plugin-import)
* [`eslint-plugin-webdriverio`](https://www.npmjs.com/package/eslint-plugin-webdriverio)

Supports the following:

* Jest
* Mocha (for webdriverio E2E tests)
* webdriverio
* ES6
* CommonJS
* Browser
* Node
* JSDoc

## JSDoc rules

The following rules are used for setting types for `@param` and `@returns`:

| Wrong     | Preferred  |
| --------- | -------    |
|`Boolean`  | `boolean`  |
|`Number`   | `number`   |
|`String`   | `string`   |
|`array`    | `Array`    |
|`function` | `Function` |
|`object`   | `Object`   |
|`promise`  | `Promise`  |

## Usage in CrowdLab UI

**You don't need to install this separately in CrowdLab UI projects.**

## Usage Outside of CrowdLab UI

If you want to use this package outside of the CrowdLab UI project, you can
install and use it with the following steps.

## Install

In order to install all peer dependencies, we need to run the following:

```sh
yarn add -D eslint-config-crowdlab
```

## Usage

Create a file named `.eslintrc.js` with following contents in the root folder of your project:

```js
{
  extends: 'crowdlab',
  rules: {
    // Add overrides and additional rules here
  }
}
```

That's it! You can override the settings from `eslint-config-crowdlab` by editing the `.eslintrc.js` file. Learn more about [configuring ESLint](http://eslint.org/docs/user-guide/configuring) on the ESLint website.
