const fs = require('fs');
const eslint = require('eslint');

function getErrors(configFile, fileToTest) {
  const CLIEngine = eslint.CLIEngine;

  const cli = new CLIEngine({
    configFile,
  });

  return cli.executeOnText(fs.readFileSync(fileToTest, 'utf8'));
}

describe('Validate ESLint configs', () => {
  it(`load config in ESLint to validate all rules are correct`, () => {
    const result = getErrors('src/index.js', 'src/stubFile.js');

    const { messages } = result.results[0]

    expect(messages).toEqual([]);
  });
});